package com.uas.platform.b2b.event;

import com.uas.platform.b2b.model.PagingRelease;
import com.uas.platform.b2b.model.PagingReleaseDetail;
import com.uas.platform.b2b.model.PurchaseOrderChange;
import com.uas.platform.core.model.Constant;

import java.util.Date;
import java.util.List;

/**
 * 采购变更单保存时生成消息事件
 *
 *
 */
public class PurchaseOrderChangeSaveReleaseEvent extends SaveReleaseEvent<PagingReleaseDetail, PurchaseOrderChange> {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	public PurchaseOrderChangeSaveReleaseEvent(List<PurchaseOrderChange> savedList) {
        super(savedList);
    }

    /**
     * 生成对应消息记录
     *
     * @param change
     * @return
     */
    @Override
	public PagingReleaseDetail release(PurchaseOrderChange change) {
        //TODO 保存新订单之后，触发新增消息事件。
        Long emUU = change.getUserUU();
        String emName = change.getRecorder();
        Long enUU = change.getEnUU();
        Date date = new Date();
        String codeValue = change.getCode();
        String from = "B2B";
        if (change.getErpId() != null) { // erp传到平台的单据，包含erpId字段记录来源
            from = "ERP";
        }
        String type = "新增采购订单";
        String title = "B2B商务提醒";
        Short toVendor = Constant.YES;
        Short isReply = Constant.NO;
        String category = "sale";  // 对接收方来说，该单据类型
        String table = "purc$changes";
        Long sourceId = change.getId();
        String url = "#/sale/change/" + change.getId();
        Short orderStatus = change.getStatus();
        String context;
        if (change.isAgreed() || change.getUnNeedReply() == Constant.YES) {
            context = change.getEnterprise().getEnName() + "的" + emName + "变更了采购单（" + codeValue + ")！";

        } else {
            context = change.getEnterprise().getEnName() + "的" + emName + "发起了采购单（" + codeValue + ")的变更，需要您确认！";
        }
        PagingRelease release = new PagingRelease(emUU, emName, enUU, date, codeValue, from, title, context, type, isReply, category, table, sourceId, orderStatus, toVendor, url);
        Long vendUU = change.getVendUU();
        Long vendUserUU = change.getVendUserUU();
        if (null == vendUserUU) {
            vendUserUU = 1L;
        }
        String vendUserName = "业务员";
        PagingReleaseDetail releaseDetail = new PagingReleaseDetail(vendUU, vendUserUU, vendUserName);
        releaseDetail.setPagingRelease(release);
        return releaseDetail;
    }
}
